/*
 * Copyright (C) 2017-2019 Global Graphics Software Ltd. All rights reserved.
 */

#ifndef EDLBLACKPOINTCOMPENSATION_H
#define EDLBLACKPOINTCOMPENSATION_H

#include <edl/edlnamespaces.h>

/**
 * @file     edlblackpointcompensation.h
 * @ingroup  IDom
 * @brief    Simple enum for black point compensation
 */

_BEGIN_EDL_NAMESPACE

/**
 * @enum     eBlackPointCompensation
 * @ingroup  IDom
 * @brief    Black point compensation enumeration
 */
typedef enum
{
    eBPCDefault = 0, //!< Default behavior
    eBPCOn      = 1, //!< Use black point compensation if applicable during color conversion
    eBPCOff     = 2, //!< Do not use black point compensation during color conversion
} eBlackPointCompensation;

_END_EDL_NAMESPACE

#endif
