// --------------------------------------------------------------------------------------------------------------------
// <copyright file="MakoElement.cs" company="Global Graphics Software Ltd">
//   Copyright (c) 2017 Global Graphics Software Ltd. All rights reserved.
// </copyright>
// --------------------------------------------------------------------------------------------------------------------

using System;

namespace Mako.Wrapper
{
    public class MakoElement : IMakoElement
    {
        private readonly IntPtr m_handle;

        public MakoElement(IntPtr handle)
        {
            m_handle = handle;
        }

        public MakoRect GetBoundingBox()
        {
            var nativeRect = new MakoRect();
            MakoDll.fnGetElementBoundingBox(m_handle, ref nativeRect);

            return nativeRect;
        }

        public void SetBoundingBox(MakoRect makoRect, bool isInvertedHorizontally, bool isInvertedVertically)
        {
            MakoDll.fnSetElementBoundingBox(m_handle, makoRect, isInvertedHorizontally, isInvertedVertically);
        }

        public IntPtr GetNodeHandle() => MakoDll.fnGetElementNode(m_handle);

        public int GetPageIndex() => MakoDll.fnGetElementPageIndex(m_handle);

        public IntPtr GetElementHandle() => m_handle;

        public IMakoElement Copy(int newPageIndex) => new MakoElement(MakoDll.fnCopyElement(m_handle, newPageIndex));

        public void Dispose() => MakoDll.fnCloseElement(m_handle);
    }
}