﻿// -----------------------------------------------------------------------
//  <copyright file="MakoLayer.cs" company="Global Graphics Software Ltd">
//      Copyright (c) 2017 Global Graphics Software Ltd. All rights reserved.
//  </copyright>
// -----------------------------------------------------------------------

using System;

namespace Mako.Wrapper
{
    public class MakoLayer : IMakoLayer
    {
        private readonly IntPtr m_handle;

        public MakoLayer(IntPtr handle)
        {
            m_handle = handle;
        }

        public string GetName()
        {
            return MakoDll.fnGetLayerName(m_handle);
        }

        public bool GetIsVisible()
        {
            return MakoDll.fnGetLayerIsVisible(m_handle);
        }

        public void SetIsVisible(bool value)
        {
            MakoDll.fnSetLayerIsVisible(m_handle, value);
        }

        public bool GetIsLocked()
        {
            return MakoDll.fnGetLayerIsLocked(m_handle);
        }

        public void SetIsLocked(bool value)
        {
            MakoDll.fnSetLayerIsLocked(m_handle, value);
        }

        public bool GetIsPrintable()
        {
            return MakoDll.fnGetLayerIsPrintVisible(m_handle);
        }

        public void Dispose()
        {
            MakoDll.fnFreeLayer(m_handle);
        }
    }
}
