// --------------------------------------------------------------------------------------------------------------------
// <copyright file="MakoRenderer.cs" company="Global Graphics Software Ltd">
//   Copyright (c) 2017 Global Graphics Software Ltd. All rights reserved.
// </copyright>
// <summary>
//   
// </summary>
// --------------------------------------------------------------------------------------------------------------------

using System;

namespace Mako.Wrapper
{
    public class MakoRenderer : IMakoRenderer
    {
        private readonly IntPtr m_handle;

        public MakoRenderer(IntPtr handle)
        {
            m_handle = handle;
        }

        public void GetRaster(IntPtr documentHandle, int pageIndex, MakoSize destinationSize, MakoRect sourceRect, string[] separations, int nSeparation, ref MakoRaster raster)
        {
            MakoDll.fnGetRaster(m_handle, documentHandle, pageIndex, destinationSize, sourceRect, separations, nSeparation, ref raster);
        }

        public void FreeRaster(MakoRaster raster)
        {
            MakoDll.fnFreeRaster(raster);
        }

        public void Dispose()
        {
            if (m_handle != IntPtr.Zero)
                MakoDll.fnCloseRenderer(m_handle);
        }
    }
}