﻿// -----------------------------------------------------------------------
//  <copyright file="ChangeTracker.cpp" company="Global Graphics Software Ltd">
//      Copyright (c) 2018 Global Graphics Software Ltd. All rights reserved.
//  </copyright>
// -----------------------------------------------------------------------

#include "stdafx.h"
#include "ChangeTracker.h"
#include <vector>
#include "MakoDocument.h"
#include "Types.h"

ChangeTracker::ChangeTracker() : m_changedElements(std::vector<MakoElement*>()), m_changeType(eSCNone)
{
}

ChangeTrackerPtr ChangeTracker::create()
{
    return ChangeTrackerPtr(new ChangeTracker());
}

void ChangeTracker::registerChangeType(const eStateChangeType changeType)
{
    m_changeType |= changeType;
}

void ChangeTracker::registerChangedElement(MakoElement* element)
{
    m_changedElements.push_back(element);
}

void ChangeTracker::registerChangedPage(const int pageIndex)
{
    m_changedPages.push_back(pageIndex);
}

std::vector<int> ChangeTracker::getChangedPages() const
{
    return m_changedPages;
}

eStateChangeType ChangeTracker::getChangeType() const
{
    return static_cast<eStateChangeType>(m_changeType);
}

std::vector<MakoElement*> ChangeTracker::getChangedElements() const
{
    return m_changedElements;
}

