﻿// -----------------------------------------------------------------------
//  <copyright file="ChangeTracker.h" company="Global Graphics Software Ltd">
//      Copyright (c) 2018 Global Graphics Software Ltd. All rights reserved.
//  </copyright>
// -----------------------------------------------------------------------

#pragma once

#include <jawsmako/jawsmako.h>
#include <memory>
#include <vector>

using namespace JawsMako;

typedef enum
{
    eSCNone = 0,
    eSCPages = 1,
    eSCSeparations = 2,
    eSCLayers = 4
} eStateChangeType;

class MakoElement;

class ChangeTracker;
typedef std::shared_ptr<ChangeTracker> ChangeTrackerPtr;

class ChangeTracker
{
public:
    static ChangeTrackerPtr create();

    void registerChangeType(eStateChangeType changeType);
    void registerChangedElement(MakoElement* element);
    void registerChangedPage(int pageIndex);

    std::vector<int> getChangedPages() const;
    eStateChangeType getChangeType() const;
    std::vector<MakoElement*> getChangedElements() const;

private:
    ChangeTracker();

    std::vector<MakoElement*> m_changedElements;
    std::vector<int> m_changedPages;
    int m_changeType;
};
