﻿// -----------------------------------------------------------------------
//  <copyright file="ElementInsertionModifier.h" company="Global Graphics Software Ltd">
//      Copyright (c) 2018 Global Graphics Software Ltd. All rights reserved.
//  </copyright>
// -----------------------------------------------------------------------

#pragma once
#include "IDocumentModifier.h"
#include "MakoLayer.h"

class MakoLayer;

class ElementInsertionModifier : public IDocumentModifier
{
public:
    static IDocumentModifierPtr create(IPagePtr page, int pageIndex, IDOMNodePtr newNode, IDOMNodePtr parentNode, MakoLayerPtr targetLayer = {});

    bool undo(StateTrackerPtr stateTracker, ChangeTrackerPtr changeTracker) override;
    bool redo(StateTrackerPtr stateTracker, ChangeTrackerPtr changeTracker) override;

private:
    ElementInsertionModifier(IPagePtr parentPage, int pageIndex, IDOMNodePtr newNode, IDOMNodePtr parentNode, MakoLayerPtr targetLayer);

    IPagePtr m_parentPage;
    int m_pageIndex;
    IDOMNodePtr m_newNode;
    IDOMNodePtr m_parentNode;
    MakoLayerPtr m_targetLayer;
};
