﻿// -----------------------------------------------------------------------
//  <copyright file="ElementTransformModifier.h" company="Global Graphics Software Ltd">
//      Copyright (c) 2018 Global Graphics Software Ltd. All rights reserved.
//  </copyright>
// -----------------------------------------------------------------------

#pragma once
#include "IDocumentModifier.h"

class ElementTransformModifier : public IDocumentModifier
{
public:

    ElementTransformModifier(IPagePtr parentPage, int pageIndex, IDOMNodePtr node, FMatrix originalNodeTransform, FMatrix newNodeTransform);
    static IDocumentModifierPtr create(IPagePtr parentPage, int pageIndex, IDOMNodePtr node, FMatrix originalNodeTransform, FMatrix newNodeTransform);

    bool undo(StateTrackerPtr stateTracker, ChangeTrackerPtr changeTracker) override;
    bool redo(StateTrackerPtr stateTracker, ChangeTrackerPtr changeTracker) override;

private:
    static void setNodeRenderTransform(const IDOMNodePtr& node, const FMatrix matrix);

    IPagePtr m_parentPage;
    IDOMNodePtr m_node;
    FMatrix m_originalNodeTransform;
    FMatrix m_newNodeTransform;
    int m_pageIndex;
};
