// -----------------------------------------------------------------------
//  <copyright file="GLock.h" company="Global Graphics Software Ltd">
//      Copyright (c) 2017 Global Graphics Software Ltd. All rights reserved.
//  </copyright>
// -----------------------------------------------------------------------

#ifndef GLOCK_H
#define GLOCK_H
#include <Windows.h>

class GCRITICAL_SECTION
{
    public:
        GCRITICAL_SECTION()  { InitializeCriticalSection(&m_criticalSection); }
        ~GCRITICAL_SECTION() { DeleteCriticalSection(&m_criticalSection);    }

        void enter() { EnterCriticalSection(&m_criticalSection); }
        void leave() { LeaveCriticalSection(&m_criticalSection); }


    private: 
        CRITICAL_SECTION m_criticalSection;
};

class GLock
{
    public:
        GLock(GCRITICAL_SECTION *gCriticalSection) : m_gCriticalSection(gCriticalSection)
        {
            m_gCriticalSection->enter();
        }
        
        ~GLock(void)
        {
            m_gCriticalSection->leave();
        }

    private: 
        GCRITICAL_SECTION * m_gCriticalSection;
};
#endif // GLOCK_H
