﻿// -----------------------------------------------------------------------
//  <copyright file="GlyphsOffsetNode.cpp" company="Global Graphics Software Ltd">
//      Copyright (c) 2018 Global Graphics Software Ltd. All rights reserved.
//  </copyright>
// -----------------------------------------------------------------------

#include "stdafx.h"
#include "GlyphsOffsetNode.h"
#include <jawsmako/jawsmako.h>
#include "IOffsetSource.h"
#include <jawsmako/transforms.h>

IOffsetSourcePtr GlyphsOffsetNode::create(const IDOMGlyphsPtr glyphsNode)
{
    IOffsetSource* offsetNode = new GlyphsOffsetNode(glyphsNode);
    return IOffsetSourcePtr(offsetNode);
}

IDOMPathNodePtr GlyphsOffsetNode::getPathData()
{
    IDOMPathNodePtr path;
    if (!m_glyphsNode->getEquivalentPath(path))
        throw std::runtime_error("Couldn't create equivalent glyph path for contour creation.");

    return path;
}

FMatrix GlyphsOffsetNode::getPathTransform()
{
    CTransformState nodeTransform(m_glyphsNode);
    return nodeTransform.transform;
}

bool GlyphsOffsetNode::getIsFilled()
{
    IDOMBrushPtr fill;
    m_glyphsNode->getFill(fill);

    return fill != nullptr;
}

GlyphsOffsetNode::GlyphsOffsetNode(const IDOMGlyphsPtr glyphsNode) : m_glyphsNode(glyphsNode)
{
}
