﻿// -----------------------------------------------------------------------
//  <copyright file="GlyphsOffsetNode.h" company="Global Graphics Software Ltd">
//      Copyright (c) 2018 Global Graphics Software Ltd. All rights reserved.
//  </copyright>
//  <summary>
//  This example is provided on an "as is" basis and without warranty of any kind.
//  Global Graphics Software Ltd. does not warrant or make any representations regarding the use or
//  results of use of this example.
//  </summary>
// -----------------------------------------------------------------------

#pragma once

#include <edl/idomglyphs.h>
#include "IOffsetSource.h"

class GlyphsOffsetNode : public IOffsetSource
{
public:
    static IOffsetSourcePtr create(IDOMGlyphsPtr glyphsNode);

protected:
    GlyphsOffsetNode(IDOMGlyphsPtr glyphsNode);

    IDOMPathNodePtr getPathData() override;
    FMatrix getPathTransform() override;
    bool getIsFilled() override;

private:
    IDOMGlyphsPtr m_glyphsNode;
    IJawsMakoPtr m_jawsMako;
};
