﻿// -----------------------------------------------------------------------
//  <copyright file="HitDetection.h" company="Global Graphics Software Ltd">
//      Copyright (c) 2018 Global Graphics Software Ltd. All rights reserved.
//  </copyright>
// -----------------------------------------------------------------------

#pragma once

#include <jawsmako/transforms.h>
#include "HitDetectionResult.h"

using namespace JawsMako;

class HitDetection
{
public:

    /**
     * Finds a node on at the supplied point, within the node tree. The selected node will be the node one beyond the selected node.
     */
    static bool findNode(IDOMNodePtr node, CTransformState state, FPoint pagePoint, IDOMNodePtr& selectedNode, HitDetectionResult& result);

    /**
    * Finds a node on at the supplied point, within the node tree.
    */
    static bool findNode(const IDOMNodePtr node, const CTransformState state, const FPoint pagePoint, HitDetectionResult& result);

private:
    static bool findNodeInternal(IDOMNodePtr node, CTransformState state, FPoint pagePoint, IDOMNodePtr& selectedNode, bool& selectedNodeFound, HitDetectionResult& result);
    static bool tryFindNode(IDOMNodePtr node, CTransformState state, FPoint pagePoint, IDOMNodePtr& selectedNode, bool& selectedNodeFound, HitDetectionResult& result);
};
