﻿// -----------------------------------------------------------------------
//  <copyright file="IDocumentModifier.h" company="Global Graphics Software Ltd">
//      Copyright (c) 2018 Global Graphics Software Ltd. All rights reserved.
//  </copyright>
// -----------------------------------------------------------------------

#pragma once

#include "ChangeTracker.h"

class IDocumentModifier;
typedef std::shared_ptr<IDocumentModifier> IDocumentModifierPtr;

class StateTracker;
typedef std::shared_ptr<StateTracker> StateTrackerPtr;

class IDocumentModifier
{
public:
    virtual ~IDocumentModifier() = default;
    virtual bool undo(StateTrackerPtr stateTracker, ChangeTrackerPtr changeTracker) = 0;
    virtual bool redo(StateTrackerPtr stateTracker, ChangeTrackerPtr changeTracker) = 0;
};
