﻿// -----------------------------------------------------------------------
//  <copyright file="IOffsetSource.h" company="Global Graphics Software Ltd">
//      Copyright (c) 2018 Global Graphics Software Ltd. All rights reserved.
//  </copyright>
//  <summary>
//  This example is provided on an "as is" basis and without warranty of any kind.
//  Global Graphics Software Ltd. does not warrant or make any representations regarding the use or
//  results of use of this example.
//  </summary>
// -----------------------------------------------------------------------

#pragma once
#include <edl/idomnode.h>
#include <memory>
#include <jawsmako/jawsmako.h>
#include <edl/idompath.h>
#include "Types.h"

using namespace JawsMako;

class IOffsetSource;
typedef std::shared_ptr<IOffsetSource> IOffsetSourcePtr;

class IOffsetSource
{
public:
    virtual ~IOffsetSource() = default;

    static IOffsetSourcePtr create(IDOMNodePtr node);

    virtual FMatrix getPathTransform() = 0;
    virtual bool getIsFilled() = 0;

    IDOMPathGeometryPtr createFlattenedGeometry(IJawsMakoPtr mako, eContourAlignment alignment);

protected:
    virtual IDOMPathNodePtr getPathData() = 0;
};
