﻿// -----------------------------------------------------------------------
//  <copyright file="LayerAddModifier.h" company="Global Graphics Software Ltd">
//      Copyright (c) 2018 Global Graphics Software Ltd. All rights reserved.
//  </copyright>
// -----------------------------------------------------------------------

#pragma once

#include <jawsmako/jawsmako.h>
#include "IDocumentModifier.h"
#include "MakoDocument.h"

using namespace JawsMako;

class LayerAddModifier : public IDocumentModifier
{
public:
    LayerAddModifier(IJawsMakoPtr jawsMako, MakoDocument* document, const String& layerName);
    static IDocumentModifierPtr create(IJawsMakoPtr jawsMako, MakoDocument* document, const String& layerName);

    bool undo(StateTrackerPtr stateTracker, ChangeTrackerPtr changeTracker) override;
    bool redo(StateTrackerPtr stateTracker, ChangeTrackerPtr changeTracker) override;

private:
    IJawsMakoPtr m_mako;
    MakoDocument* m_document;
    String m_layerName;
    MakoLayerPtr m_layer;
};
