﻿// -----------------------------------------------------------------------
//  <copyright file="LayerLockStateModifier.h" company="Global Graphics Software Ltd">
//      Copyright (c) 2018 Global Graphics Software Ltd. All rights reserved.
//  </copyright>
// -----------------------------------------------------------------------

#pragma once

#include <jawsmako/jawsmako.h>
#include "IDocumentModifier.h"

using namespace JawsMako;

class LayerLockStateModifier : public IDocumentModifier
{
public:
    LayerLockStateModifier(IJawsMakoPtr mako, IOptionalContentPtr optionalContent, IOptionalContentGroupPtr optionalContentGroup, int lockGroupIndex, bool newLayerLockState);
    static IDocumentModifierPtr create(IJawsMakoPtr mako, IOptionalContentPtr optionalContent, IOptionalContentGroupPtr optionalContentGroup, int lockGroupIndex, bool newLayerLockState);

    bool undo(StateTrackerPtr stateTracker, ChangeTrackerPtr changeTracker) override;
    bool redo(StateTrackerPtr stateTracker, ChangeTrackerPtr changeTracker) override;

private:
    void updateLocktate(bool state);

    IOptionalContentPtr m_optionalContent;
    IOptionalContentGroupPtr m_optionalContentGroup;
    bool m_newLayerLockState;
    int32 m_groupIndex;
    IJawsMakoPtr m_mako;
};
