﻿// -----------------------------------------------------------------------
//  <copyright file="LayerVisibilityModifier.h" company="Global Graphics Software Ltd">
//      Copyright (c) 2018 Global Graphics Software Ltd. All rights reserved.
//  </copyright>
// -----------------------------------------------------------------------

#pragma once

#include <jawsmako/jawsmako.h>
#include "IDocumentModifier.h"

using namespace JawsMako;

class LayerVisibilityModifier : public IDocumentModifier
{
public:
    LayerVisibilityModifier(IJawsMakoPtr mako, IOptionalContentPtr optionalContent, IOptionalContentGroupPtr optionalContentGroup, bool newLayerVisibility);
    static IDocumentModifierPtr create(IJawsMakoPtr mako, IOptionalContentPtr optionalContent, IOptionalContentGroupPtr optionalContentGroup, bool newLayerVisibility);

    bool undo(StateTrackerPtr stateTracker, ChangeTrackerPtr changeTracker) override;
    bool redo(StateTrackerPtr stateTracker, ChangeTrackerPtr changeTracker) override;

private:
    void updateState(bool state) const;
    void setGroupVisible(bool visible) const;
    IOptionalContentPtr m_optionalContent;
    IOptionalContentGroupPtr m_optionalContentGroup;
    bool m_newLayerVisibility;
    IJawsMakoPtr m_mako;
};
