﻿// -----------------------------------------------------------------------
//  <copyright file="MakoDebug.h" company="Global Graphics Software Ltd">
//      Copyright (c) 2018 Global Graphics Software Ltd. All rights reserved.
//  </copyright>
//  <summary>
//  This example is provided on an "as is" basis and without warranty of any kind.
//  Global Graphics Software Ltd. does not warrant or make any representations regarding the use or
//  results of use of this example.
//  </summary>
// -----------------------------------------------------------------------

#pragma once

#include <edl/idomnode.h>
#include <edl/idomoutline.h>

/**
 * @return the node type as a string.
 */
std::string getNodeType(const EDL::IDOMNodePtr& node);

/**
 * Write info about a single node to stdout.
 */
void dumpNodeInfo(const EDL::IDOMNodePtr& node, bool markNode = false, int depth = 0);

/**
 * Write info about a node and any children to stdout.
 */
void dumpNodeTree(const EDL::IDOMNodePtr& node, int markAtDepth = -1, int depth = 0);

/**
 * Write info about a node, including its parents and children, to stdout.
 */
void dumpNodeInTree(const EDL::IDOMNodePtr& node);
