// -----------------------------------------------------------------------
//  <copyright file="MakoLayer.h" company="Global Graphics Software Ltd">
//      Copyright (c) 2017 Global Graphics Software Ltd. All rights reserved.
//  </copyright>
// -----------------------------------------------------------------------

#pragma once

#include <jawsmako/types.h>
#include "StateTracker.h"
#include <edl/idompath.h>

using namespace JawsMako;

class MakoLayer;
typedef std::shared_ptr<MakoLayer> MakoLayerPtr;

class MakoLayer
{
public:
    MakoLayer(IJawsMakoPtr mako, IOptionalContentPtr optionalContent, IOptionalContentGroupPtr optionalContentGroup, StateTrackerPtr stateTracker);
    ~MakoLayer();
    String getName() const;
    bool isPrintVisible() const;
    bool getIsLocked() const;
    void setIsLocked(bool isLocked) const;
    bool getIsVisible() const;
    void setIsVisible(bool isVisible) const;
    IOptionalContentPtr getOptionalContent() const;
    IOptionalContentGroupPtr getOptionalContentGroup() const;
    int getLockedGroupIndex() const;
    IDOMNodePtr addReferenceToNode(const IDOMNodePtr& node) const;

private:
    StateTrackerPtr m_stateTracker;
    IOptionalContentPtr m_optionalContent;
    IOptionalContentGroupPtr m_optionalContentGroup;
    IJawsMakoPtr m_mako;
};
