// -----------------------------------------------------------------------
//  <copyright file="MakoRenderer.h" company="Global Graphics Software Ltd">
//      Copyright (c) 2017 Global Graphics Software Ltd. All rights reserved.
//  </copyright>
// -----------------------------------------------------------------------

#ifndef MAKORENDERER_H
#define MAKORENDERER_H

#include <jawsmako/types.h>
#include <jawsmako/transforms.h>
#include "Types.h"

using namespace JawsMako;

class MakoRenderer
{
public:
    MakoRenderer(IJawsMakoPtr mako);
    ~MakoRenderer();
    void getPageRaster(const IPagePtr& page, MakoSize destinationSize, const MakoRect& sourceRect, IOptionalContentPtr optionalContent, wchar_t** separations, int nSeparation, MakoRaster* raster);
    static void freeRaster(MakoRaster& raster);

private:
    IJawsMakoPtr m_mako;
    IJawsRendererPtr m_jawsRenderer;
    IDOMColorSpacePtr m_deviceCMYKColourSpace;
    IDOMColorSpacePtr m_sRGBColorSpace;
    IOptionalContentFixerTransformPtr m_optionalContentFixer;

    void applyPageTransform(IPagePtr page) const;
    static bool showSeparation(String separation, wchar_t** allShownSeparations, int nSeparations);
};

#endif // MAKORENDERER_H
