﻿// -----------------------------------------------------------------------
//  <copyright file="PathOffsetNode.cpp" company="Global Graphics Software Ltd">
//      Copyright (c) 2018 Global Graphics Software Ltd. All rights reserved.
//  </copyright>
// -----------------------------------------------------------------------

#include "stdafx.h"
#include "PathOffsetNode.h"
#include "IOffsetSource.h"
#include <jawsmako/jawsmako.h>
#include <jawsmako/transforms.h>

IOffsetSourcePtr PathOffsetNode::create(const IDOMPathNodePtr node)
{
    IOffsetSource* source = new PathOffsetNode(node);
    return IOffsetSourcePtr(source);
}

IDOMPathNodePtr PathOffsetNode::getPathData()
{
    return m_node;
}

bool PathOffsetNode::getIsFilled()
{
    IDOMBrushPtr fill;
    m_node->getFill(fill);

    return fill != nullptr;
}

FMatrix PathOffsetNode::getPathTransform()
{
    CTransformState nodeTransform(m_node);
    return nodeTransform.transform;
}

PathOffsetNode::PathOffsetNode(const IDOMPathNodePtr node): m_node(node)
{
}
