﻿// -----------------------------------------------------------------------
//  <copyright file="PathOffsetNode.h" company="Global Graphics Software Ltd">
//      Copyright (c) 2018 Global Graphics Software Ltd. All rights reserved.
//  </copyright>
//  <summary>
//  This example is provided on an "as is" basis and without warranty of any kind.
//  Global Graphics Software Ltd. does not warrant or make any representations regarding the use or
//  results of use of this example.
//  </summary>
// -----------------------------------------------------------------------

#pragma once

#include "jawsmako/jawsmako.h"
#include <edl/idompath.h>
#include "IOffsetSource.h"

using namespace JawsMako;

class PathOffsetNode : public IOffsetSource
{
public:
    static IOffsetSourcePtr create(IDOMPathNodePtr node);

protected:
    PathOffsetNode(IDOMPathNodePtr node);

    IDOMPathNodePtr getPathData() override;
    FMatrix getPathTransform() override;
    bool getIsFilled() override;

private:
    IDOMPathNodePtr m_node;
};
